/*----------------------------------------------------------------------------
 * Name:    Blinky.c
 * Purpose: LED Flasher
 * Note(s): Blinky example for XMC4800
 *----------------------------------------------------------------------------
 * Blink LED connected with P3.5
 * XMC4800 board
 *
 *----------------------------------------------------------------------------*/

#include <stdio.h>
#include <XMC4800.h>
#include "LED.h"



volatile uint32_t msTicks;                      /* counts 1ms timeTicks       */
/*----------------------------------------------------------------------------
  SysTick_Handler
 *----------------------------------------------------------------------------*/
void SysTick_Handler(void) {
  msTicks++;
}

/*----------------------------------------------------------------------------
  delays number of tick Systicks (happens every 1 ms)
 *----------------------------------------------------------------------------*/
void Delay (uint32_t dlyTicks) {
  uint32_t curTicks;

  curTicks = msTicks;
  while ((msTicks - curTicks) < dlyTicks) { __NOP(); }
}


/*----------------------------------------------------------------------------
  MAIN function
 *----------------------------------------------------------------------------*/
int main (void) {

  SystemCoreClockUpdate();                      /* update SystemCoreClock     */
  if (SysTick_Config(SystemCoreClock / 1000)) { /* SysTick 1 msec interrupts  */
    while (1) __NOP();                          /* Capture error              */
  }

  LED_Init();

  while(1) {                                    /* Loop forever      */

    LED_On ();                               /* Turn on LED'         */
    Delay(550);                              /* Delay 550ms       */
    LED_Off();                               /* Turn off LED '       */
    Delay(550);                              /* Delay 550ms       */

  }

}
